#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

#define BUFSIZE 1024
#define PORT "13"

int main(const int ParmCount, const char* Parameter[]) {
  char buf[BUFSIZE] = { '\0' };
  int sock;
  int n;
  struct addrinfo hints;
  struct addrinfo* res;
  struct addrinfo* r;

  if(ParmCount != 2) {
    fprintf(stderr,"usage: gettime timeserver\n");
    return 1;
  }

  memset(&hints, 0, sizeof(hints));
  hints.ai_family = AF_UNSPEC;
  hints.ai_socktype = SOCK_STREAM;

  if((n = getaddrinfo(Parameter[1], PORT, &hints, &res)) != 0) {
    fprintf(stderr, "getaddrinfo: %s\n", gai_strerror(n));
    return 1;
  }

  for(r=res; r != NULL; r = r->ai_next) {
    if((sock = socket(r->ai_family, r->ai_socktype, r->ai_protocol)) < 0) {
      continue;
    }
    if (connect(sock, r->ai_addr, r->ai_addrlen) < 0) {
      close(sock);
      continue;
    }
    break;
  }

  if (r == NULL) {
    fprintf(stderr, "can't connect\n");
    return 2;
  }
  printf("conneced to %s...\n", Parameter[1]);

  freeaddrinfo(res);

  if ((n = recv(sock, buf, BUFSIZE-1, 0)) < 0) {
    fprintf(stderr, "read error\n");
    return 1;
  }
  printf("%s\n",buf);

  close(sock);

  return 0;
}

